import 'package:flutter/material.dart';
class Adapt {
	static MediaQueryData sMediaQuery;
	static double _width;
	static double _height;
	static double _topBarH;
	static double _botBarH;
	static double _pixelRatio;
	static double _ratio;
	static double _widthRatio = 1.0;
	static double _heightRatio;
	static const remRootSize = 53.33;

	/// allowFontScaling  字体跟随系统字体大小缩放，默认禁止
	static bool _allowFontScaling = false;
	double remSize;
	double pageWidth;
	double ratio;
	Adapt({this.remSize, this.pageWidth}) {
		ratio = _width / pageWidth;
	}
	static const int STANDARD_UI_WIDTH = 750;
	static const int STANDARD_UI_HEIGHT = 1334;
	static double _textScaleFactor;
	static init(
			[int number,
				MediaQueryData mediaQuery,
				int standardHeight,
				int marginWidth,
				int marginHeight,
				bool allowFontScaling = false]) {
		// release版本下mediaQuery的取值有延迟，暂时现在init的时候轮询解决
		int uiWidth = number is int ? number : STANDARD_UI_WIDTH;
		int uiHeight = standardHeight is int ? standardHeight : STANDARD_UI_HEIGHT;
		_allowFontScaling = allowFontScaling;
		marginWidth = marginWidth ?? 0;
		marginHeight = marginHeight ?? 0;
		if (mediaQuery != null) {
			Adapt.sMediaQuery = mediaQuery;
			_width = sMediaQuery.size.width - marginWidth;
			_height = sMediaQuery.size.height - marginHeight;
			// 横屏状态下修改
			if (_width > _height) {
				_width = sMediaQuery.size.height - marginHeight;
				_height = sMediaQuery.size.width - marginWidth;
			}
			_topBarH = sMediaQuery.padding.top;
			_botBarH = sMediaQuery.padding.bottom;
			_pixelRatio = sMediaQuery.devicePixelRatio;
			_widthRatio = _width / uiWidth;
			_heightRatio = _height / uiHeight;
			_textScaleFactor = mediaQuery.textScaleFactor;
		} else {
			_widthRatio = 1;
			_heightRatio = 1;
		}
		if (_widthRatio < _heightRatio) {
			_ratio = _widthRatio;
		} else {
			_ratio = _heightRatio;
		}
	}

	// 默认以宽度为基准进行缩放
	static px(num number) {
		return pxByWidth(number);
	}

	// 以高度为缩放基准
	static pxByHeight(num number) {
		return number * _heightRatio;
	}

	// 以宽度作为缩放基准
	static pxByWidth(num number) {
		print('width:${_width}');
		return number * _width / 750;
	}

	// 宽度高度中选择最小的比例进行缩放
	static pxByinimumSize(num number) {
		return number * _ratio;
	}

	static remToPx(double number) {
		return px(number * remRootSize);
	}

	double rem2Px(double rem) {
		return ((rem * remSize).toInt()) * ratio;
	}

	static onePx() {
		return 1 / _pixelRatio;
	}

	static screenW() {
		return _width;
	}

	static screenH() {
		return _height;
	}

	static padTopH() {
		return _topBarH;
	}

	static padBotH() {
		return _botBarH;
	}

	// 设置字体
	static setSp(num fontSize) => _allowFontScaling
			? pxByWidth(fontSize)
			: pxByWidth(fontSize) / _textScaleFactor;
}